<?php
class Form
{
	private $dbh;
	private $module; // Parent module
	private $form_action;
	private $form_template;
	private $action_parameter;
		
	public $db_keyname;
	public $db_keyvalue;
	public $db_table;	
	
	private $db_element; // Concrete document from database
	
	public function __set($parameter, $value)
	{
			
		if ($this->db_element)
			$this->db_element->data[$parameter] = $value;
		else
		{
			$this->db_element = new DB_Line("");
			$this->db_element->data[$parameter] = $value;				
		}		
		
	}
	
	public function __get($parameter)
	{
			
		if ($this->db_element)
			return $this->db_element->data[$parameter];		
	}
	
	public function __construct($identifier, Module $module)
	{
		$this->dbh = $module->dbh;
		$this->module = $module;
		$module_name = $module->module_name;
		
		// This gets a bit redundant data (form->template in every action) but only one select;
		// $sql = "SELECT * FROM `Form` as F natural join `Form_action` WHERE (F.form_id = '$identifier')";

		// Gets form information
		$sql = "SELECT * FROM `Form` WHERE (`form_name` = '$identifier' and `module_name` = '$module_name')";
		$dbresult = new DB_Result($this->dbh->execute($sql));
		if ($dbresult->count == 0)	new Message("2",
									"<br>Form \"$identifier\" not found",
									"javascript: history.go(-1);",
									"Form->Constructor");

		$this->form_template = $dbresult->form_template;
		$this->action_parameter = $dbresult->action_parameter;
		
		// Gets form actions
		$sql = "SELECT * FROM `Form_action` WHERE (`form_name` = '$identifier')";
		$dbresult = new DB_Result($this->dbh->execute($sql));		
		if ($dbresult->count == 0)	new Message("1",
									"<br>No form actions for Form \"$identifier\" found",
									"javascript: history.go(-1);",
									"Form->Constructor");
		
		while($frmact = $dbresult->getnext())
		{
			$this->form_action[$frmact->action_name] = array("role" => $frmact->action_role,"code" => $frmact->action_code);
		}
		
	}
	
	public function process()
	{
		$action = $_GET[$this->action_parameter];
		if(
			is_array($this->form_action) && 
			array_key_exists($action,$this->form_action) &&
			$this->module->notRestricted($this->form_action[$action][role])
			) {
				eval($this->form_action[$action][code]);
			}
		//else new Message("1","<br>Action \"$action\" not defined","javascript: history.go(-1);",			"Form->process()");
	}
	
	
	public function drawForm()
		{
			
			if ($this->form_template == "")
				echo "Template is empty";
			else
				echo evalTemplate($this->form_template,$this->db_element, $this->module);
						
		}
	
	
	public function createElement($table, $keyname, $wheretogo, $debug = 0)
	{
		
		$this->db_table = $table;
		$this->db_keyname = $keyname;
		$this->updateElement($wheretogo, $debug);
	}
	
	
	public function findElement($table, $keyname, $keyvalue)
	{
		// Finds current document in given table
		if (is_array($keyname))
			foreach ($keyname as $tmpkey) $condition .= "`$tmpkey` = '".$keyvalue[0+$i++]."' AND "; // We have multiple keys and values
		else
			$condition = "`".$keyname."` = '".$keyvalue."' AND ";
			
		$sql = "select * from `".$table."` WHERE (".$condition."1)";
		
		$dbresult = new DB_Result($this->dbh->execute($sql));
		if ($dbresult->count == 0) new Message(0,"No Element with key ($keyname = $keyvalue) found","javascript:history.go(-1);","Form->findElement");
		$this->db_element = $dbresult->getnext();
		$this->db_table = $table;
		$this->db_keyname = $keyname;
		$this->db_keyvalue = $keyvalue;
		
	}
	
	public function deleteElement($wheretogo)
	{
		if (!$this->db_element) new Message(3,"Element not found","javascript:history.go(-1);","Form->deleteElement()");
		
		if ($_GET['confirm'] != "yes")
		{
			// Delete not confirmed yet
			$conf_url = "?".http_build_query($_GET)."&confirm=yes";
			new Message(5, "Realy want to delete?",$conf_url,"Form->deleteElement()");
		}
		else
		{
			// Delete confirmed
			$this->db_element->delete($this->db_table, $this->db_keyname, $this->db_keyvalue);
			if ($wheretogo != "") echo "<script language=\"javascript\">document.location.href=\"$wheretogo\";</script>";
		}
		
	}
	
	
	public function updateElement($wheretogo, $debug = 0)
	{
		//if (count($_POST) == 0) new Message(0,"Can't process data","javascript:history.go(-1)","Form->Process");
		if (!$this->db_element)
		{
			// Element not found in database
			$this->db_element = new DB_Line("");
		}
		// Tries to save data to the database
		//echo "$this->db_table = $this->db_keyname - $this->db_keyvalue"; 
		$this->db_element->save($this->db_table,$this->db_keyname, $this->db_keyvalue, $debug);
		
		if ((!$debug) && ($wheretogo != "")) echo "<script language=\"javascript\">document.location.href=\"$wheretogo\";</script>";
	}
	
}
		
?>
