<?php

	class View
	{
		public 	$view_name;
		private  $module;
		private $select;
		private $db_result;
		private $view_template;
		private $view_header;
		private $view_footer;
		
		private $num_display_elements; // Number of displayed elements per page
		private $pos_display_elements; // Current position in listing
		private $roll_parameter; 	   // URL parameter for listing

		
		public function __construct($view_name, Module $module)
		{
			$this->view_name = $name;
			$this->module = $module;
			$module_name = $module->module_name;
			
  			include("./config/config.inc.php");			
			// Gets view information from database
			$sql = "select * from View where (`view_name` = '$view_name' and `module_name` = '$module_name');";
			$view = new DB_Result($dbh->execute($sql));
			if ($view->count == 0) new Message(2,"<br>No view called $module_name::$view_name found","javascript: history.go(-1);","View->construct");
			$this->view_template = $view->view_template;
			$this->view_header = $view->view_header;
			$this->view_footer = $view->view_footer;
			$this->num_display_elements = ($view->num_display_elements)?$view->num_display_elements:500;
			$this->roll_parameter = $view->roll_parameter;

			// Get real sql select
			$this->pos_display_elements = $_GET[$this->roll_parameter]+1-1;
			$sql = $view->select." LIMIT $this->pos_display_elements,".($this->num_display_elements+1);
			eval("\$sql = \"$sql\";"); // Maybe there is some argument to evaluate
			$this->db_result = new DB_Result($dbh->execute($sql));

		}
		
		public function drawListing()
		{
			$current_position = $_GET[$this->roll_parameter];
			// URL for previous page
			$_GET[$this->roll_parameter] = max($this->pos_display_elements-$this->num_display_elements,0); 
			$prevurl = "?".http_build_query($_GET);
			
			// URL for next page
			$_GET[$this->roll_parameter] = $this->pos_display_elements+$this->num_display_elements;
			$nexturl = "?".http_build_query($_GET);			
			echo "<div id=\"roll\">";						
			echo ($current_position)?"<span id=\"roll_button\" style=\"float: left\"><a href=\"$prevurl\">&lt;&lt;</a></span>":"";
			echo ($this->db_result->count > $this->num_display_elements)?"<span id=\"roll_button\" style=\"float: right\"><a href=\"$nexturl\">&gt;&gt;</a></span>":"";
			echo "</div>\n";
			// Return original value to $_GET parameter
			$_GET[$this->roll_parameter] = $current_position;

				
		}
		
		public function getView()
		{
			
			$retval = "";
			if ($this->view_header != "") $retval .= $this->view_header; // Prints header
			while ($doc = $this->db_result->getnext())
			{
				$retval .= evalTemplate($this->view_template,$doc, $this->module);
			}
			if ($this->view_footer != "") $retval .= $this->view_footer; // Prints header			
			return $retval;
		}
		
		public function drawView()
		{
			echo $this->getView();
		}
		
		
		public function drawSimple()
		{
			if ($this->db_result->count == 0) return false; // If there are no documents, exit
			
			$line = $this->db_result->getnext(); // Get first result;	
			// Prints header ------------------------------------------------------------------
			echo "\n<table>\n";
			echo "\t<tr>\n";
			foreach($line->data as $key => $value) echo "\t\t<td id=\"entry_key\">$key</td>\n";
			echo "\t</tr>\n";
			// --------------------------------------------------------------------------------
			
			while($line)
			{
				echo "\t<tr>\n";
				foreach($line->data as $key => $value) echo "\t\t<td id=\"entry_value\">".(($value)?$value:"&nbsp")."</td>\n";
				echo "\t</tr>\n";
				$line = $this->db_result->getnext();
			}
			echo "</table>\n";
	
		}
		
}

?>